#include <atcktarg.h>
#include <atcktargps2.h>
#include "shared.h"

#pragma force_active on

MemLog* TheBuffer;
volatile atck_uint32_t TheBufferIndex;
atcktarg_lock_t TheMutex;
atck_uint32_t TheBufferSize;

void Initialize(atck_addr_t buffer, atck_uint32_t max)
{
	TheBufferIndex = 0;
	TheBuffer = (MemLog*)buffer;
	TheBufferSize = max;
	
	atcktarg_initlock(&TheMutex);
}

void BeforeAlloc(atck_uint64_t caller_a0, atck_uint32_t callsiteID)
{
	atcktarg_lock(&TheMutex);
	while (TheBufferIndex >= TheBufferSize)
	{
		atcktarg_unlock(&TheMutex);
		atcktarg_stop();
		atcktarg_lock(&TheMutex);
	}

	TheBuffer[TheBufferIndex].bytes = (atck_uint32_t)caller_a0;
	TheBuffer[TheBufferIndex].callsiteID = callsiteID;
}

void AfterAlloc(atck_uint64_t caller_v0)
{
	TheBuffer[TheBufferIndex].ptr = (atck_addr_t)caller_v0;
	TheBufferIndex++;
	atcktarg_unlock(&TheMutex);
	
	if (TheBufferIndex >= TheBufferSize)
		atcktarg_stop();
}

void BeforeRelease(atck_uint64_t caller_a0, atck_uint32_t callsiteID)
{
	atcktarg_lock(&TheMutex);
	while (TheBufferIndex >= TheBufferSize)
	{
		atcktarg_unlock(&TheMutex);
		atcktarg_stop();
		atcktarg_lock(&TheMutex);
	}

	TheBuffer[TheBufferIndex].bytes = 0;
	TheBuffer[TheBufferIndex].callsiteID = callsiteID;
	TheBuffer[TheBufferIndex].ptr = (atck_addr_t)caller_a0;
	TheBufferIndex++;
	atcktarg_unlock(&TheMutex);

	if (TheBufferIndex >= TheBufferSize)
		atcktarg_stop();
}