#ifndef RunContext_H
#define RunContext_H

#include <atck.h>
#include <atcktypes.h>
#include <atckps2.h>

#include "Candidate.h"

class RunContext
{
public:
	RunContext(void)
	{
		m_Candidates.clear();
		m_CallSites.clear();
		m_pProg = NULL;
		m_pIProg = NULL;
		m_pCounters = NULL;
		m_nCounters = 0;
		m_aTargetBuffer = NULL;
	}
	
	~RunContext();
	bool InitSession(const char* app);
	bool BuildCandidateList(void);
	bool Instrument(void);
	bool Run(const char* prompt);
	void HandleStop(void);
	
	bool LockDevice(void);
	void UnlockDevice(void);
	
protected:
	Candidate* FindTargetInList(atck_addr_t addr, atck_uint32_t imgID);

	CandidateList	m_Candidates;
	CallSiteList	m_CallSites;
	atck_prog_t*	m_pProg;
	atck_iprog_t*	m_pIProg;
	atck_uint32_t*	m_pCounters;
	atck_uint32_t	m_nCounters;
	atck_run_t*		m_pRun;
	atck_addr_t 	m_aTargetBuffer;

	static atck_sesn_t*		s_pSession;
	static atck_uint32_t	s_nSessionLock;
	static atck_cfg_t*		s_pConfig;
	static atck_dev_t*		s_pDev;
	static atck_uint32_t	s_nDevLock;
};

#endif